/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.main.ConfigManager
 *  fire.pb.skill.Module
 *  fire.pb.skill.SActionTime
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.util.FireProp
 */
package fire.pb.battle;

import fire.pb.battle.AIOperation;
import fire.pb.battle.BattleField;
import fire.pb.battle.DemoResult;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SubResultItem;
import fire.pb.main.ConfigManager;
import fire.pb.skill.Module;
import fire.pb.skill.SActionTime;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.util.FireProp;
import java.util.List;
import java.util.Properties;

public class ScriptTimeCalc {
    public static final int ATTACK_TIME_ID = 1;
    public static final int COMBO_ATTACK_TIME_ID = 2;
    public static final int USE_ITEM_TIME_ID = 3;
    public static final int SUMMON_TIME_ID = 6;
    public static final int SUMMON_BACK_TIME_ID = 7;
    public static final int INSTANT_SUMMON_TIME_ID = 8;
    public static final int CATCH_TIME_ID = 9;
    public static final int RUNAWAY_TIME_ID = 10;
    public static final int INSTANT_RUNAWAY_TIME_ID = 11;
    public static final int OPER_FAIL_TIME_ID = 12;
    public static final int ATTACK_BACK_TIME_ID = 14;
    public static final int DEATH_TIME_ID = 22;
    public static final int KICK_OUT_TIME_ID = 23;
    public static final int CHUN_GE_TIME_ID = 24;
    public static final int ROUND_END_TIME_ID = 25;
    public static final int BETWEEN_ACTION_TIME_ID = 26;
    public static final int TOGATHER_ATTACK_TIME_ID = 28;
    public static final int MAX_SKILL_TIME_ID = 29;
    public static final int MIN_SKILL_TIME_ID = 30;
    public static final int MIN_TIME_PERCENT_ID = 31;
    public static final int MAX_TIME_PERCENT_ID = 32;
    public static final int MIN_ROUND_TIME_ID = 33;
    public static final int MAX_ROUND_TIME_ID = 34;
    public static final int DEFAULT_RESULT_TIME_ID = 35;
    public static final int SKILL_NAME_TIME_ID = 36;
    public static final int DODGE_TIME_ID = 37;
    public static final int BE_ATTACK_TIME_ID = 38;
    public static final int AI_ACTION_TIME = 40;
    public static final int SUBSKILL_ACTION_TIME = 41;
    private static final int RESULT_DEATH_GHOST = 40960;
    private static final int RESULT_DEAD_HALF_FULL_RELIVE = 0x800000;
    static Properties prop = ConfigManager.getInstance().getPropConf("battle");
    protected static final float EXT_SCRIPT_PLAY_TIME = FireProp.getIntValue((Properties)prop, (String)"mtgserv.ext_script_play_time");

    public static int calcScriptTime(List<ResultItem> script, List<AIOperation> clientAIActions, List<Integer> itemtimelist) {
        if (script.isEmpty()) {
            return ScriptTimeCalc.getScriptTimeByTimeId(33);
        }
        int sumtime = 0;
        int roundendtime = 0;
        for (ResultItem item : script) {
            int t = ScriptTimeCalc.getResultItemTime(item);
            if (item.execute.operationtype == 18) {
                if (t <= roundendtime) continue;
                roundendtime = t;
                continue;
            }
            if (t > 0) {
                itemtimelist.add(t);
            }
            sumtime += t + ScriptTimeCalc.getScriptTimeByTimeId(26);
        }
        sumtime += roundendtime;
        sumtime = (int)((float)sumtime + ((float)(clientAIActions.size() * 40) + EXT_SCRIPT_PLAY_TIME));
        return Math.max(ScriptTimeCalc.getScriptTimeByTimeId(33), Math.min(sumtime, ScriptTimeCalc.getScriptTimeByTimeId(34)));
    }

    private static int getResultItemTime(ResultItem item) {
        switch (item.execute.operationtype) {
            case 4: 
            case 5: 
            case 10: 
            case 15: {
                return 0;
            }
            case 1: {
                return ScriptTimeCalc.getAttackTime(item);
            }
            case 2: {
                return ScriptTimeCalc.getNormalSkillTime(item);
            }
            case 3: {
                return ScriptTimeCalc.getUseItemTime(item);
            }
            case 6: {
                return ScriptTimeCalc.getScriptTimeByTimeId(6);
            }
            case 7: {
                return ScriptTimeCalc.getScriptTimeByTimeId(7);
            }
            case 8: {
                return ScriptTimeCalc.getScriptTimeByTimeId(9);
            }
            case 9: {
                return ScriptTimeCalc.getScriptTimeByTimeId(10);
            }
            case 11: 
            case 19: {
                return ScriptTimeCalc.getNormalSkillTime(item);
            }
            case 12: {
                return ScriptTimeCalc.getScriptTimeByTimeId(8);
            }
            case 13: {
                return ScriptTimeCalc.getScriptTimeByTimeId(11);
            }
            case 14: 
            case 20: {
                return ScriptTimeCalc.getScriptTimeByTimeId(12);
            }
            case 16: {
                return ScriptTimeCalc.getNormalSkillTime(item);
            }
            case 17: {
                return ScriptTimeCalc.getScriptTimeByTimeId(35);
            }
            case 18: {
                return ScriptTimeCalc.getRoundEndTime(item);
            }
        }
        return ScriptTimeCalc.getScriptTimeByTimeId(35);
    }

    private static int getRoundEndTime(ResultItem item) {
        int t = ScriptTimeCalc.getScriptTimeByTimeId(25);
        for (SubResultItem subitem : item.subresultlist) {
            for (DemoResult demo : subitem.resultlist) {
                int deathtime = ScriptTimeCalc.getDeathAddTime(demo);
                if (t >= deathtime) continue;
                t = deathtime;
            }
        }
        return t;
    }

    private static DemoResult getLastDemo(ResultItem item) {
        SubResultItem lastsubitem;
        DemoResult lastdemo = null;
        if (item.subresultlist.size() > 0 && (lastsubitem = item.subresultlist.get(item.subresultlist.size() - 1)) != null) {
            lastdemo = lastsubitem.resultlist.get(lastsubitem.resultlist.size() - 1);
        }
        return lastdemo;
    }

    private static int getAttackTime(ResultItem item) {
        int time = 0;
        for (SubResultItem subitem : item.subresultlist) {
            time += ScriptTimeCalc.getSubAttackTime(subitem);
        }
        return time;
    }

    private static DemoResult getSubLastDemo(SubResultItem subitem) {
        DemoResult lastdemo = null;
        if (subitem.resultlist.size() > 0) {
            lastdemo = subitem.resultlist.get(subitem.resultlist.size() - 1);
        }
        return lastdemo;
    }

    private static int getSubAttackTime(SubResultItem item) {
        DemoResult lastdemo = ScriptTimeCalc.getSubLastDemo(item);
        if (lastdemo != null && lastdemo.assisterid > 0) {
            return ScriptTimeCalc.getScriptTimeByTimeId(28);
        }
        int time = ScriptTimeCalc.getScriptTimeByTimeId(1);
        if (lastdemo != null) {
            time += (item.resultlist.size() - 1) * ScriptTimeCalc.getScriptTimeByTimeId(2);
            time += ScriptTimeCalc.getDeathAddTime(lastdemo);
            if (lastdemo.attackback != 0) {
                time += ScriptTimeCalc.getScriptTimeByTimeId(14);
            }
        }
        return time;
    }

    private static int getDeathAddTime(DemoResult demo) {
        if ((demo.targetresult & 0x4000) != 0 || (demo.attackerresult & 0x4000) != 0) {
            return ScriptTimeCalc.getScriptTimeByTimeId(23);
        }
        if ((demo.targetresult & 0xA000) != 0 || (demo.attackerresult & 0xA000) != 0) {
            return ScriptTimeCalc.getScriptTimeByTimeId(22);
        }
        if ((demo.targetresult & 0x800000) != 0 || (demo.attackerresult & 0x800000) != 0) {
            return ScriptTimeCalc.getScriptTimeByTimeId(24);
        }
        if ((demo.targetresult & 0x200) != 0 || (demo.attackerresult & 0x200) != 0) {
            return ScriptTimeCalc.getScriptTimeByTimeId(37);
        }
        return ScriptTimeCalc.getScriptTimeByTimeId(38);
    }

    private static int getNormalSkillTime(ResultItem item) {
        int mintime;
        int time = 0;
        FightSkillConfig skillcfg = Module.getInstance().getFightSkillConfig(item.execute.operationid);
        if (skillcfg == null) {
            time = ScriptTimeCalc.getScriptTimeByTimeId(35);
        } else {
            time = skillcfg.getPlayTime();
            time += skillcfg.getSkillSpecialAddTime();
        }
        int deathtime = 0;
        for (SubResultItem subitem : item.subresultlist) {
            float ftimerate = 1.0f;
            int costtime = Module.getInstance().getSubSkillCostTimes(subitem.subskillid);
            if (costtime == 0) {
                ftimerate = 0.0f;
            } else if (costtime != -1) {
                ftimerate = 0.5f;
            }
            for (DemoResult demo : subitem.resultlist) {
                int t = ScriptTimeCalc.getDeathAddTime(demo);
                if (t <= deathtime) continue;
                deathtime = t;
            }
            deathtime = (int)((float)deathtime + (float)ScriptTimeCalc.getScriptTimeByTimeId(41) * ftimerate);
        }
        time += deathtime;
        if ((time += ScriptTimeCalc.getScriptTimeByTimeId(36)) < (mintime = ScriptTimeCalc.getScriptTimeByTimeId(30))) {
            return mintime;
        }
        int maxtime = ScriptTimeCalc.getScriptTimeByTimeId(29);
        if (time > maxtime) {
            return maxtime;
        }
        return time;
    }

    private static int getUseItemTime(ResultItem item) {
        int time = ScriptTimeCalc.getScriptTimeByTimeId(3);
        DemoResult lastdemo = ScriptTimeCalc.getLastDemo(item);
        if (lastdemo != null) {
            int t = ScriptTimeCalc.getDeathAddTime(lastdemo);
            time += t;
        }
        return time;
    }

    public static int getScriptTimeByTimeId(int timeid) {
        SActionTime cfg = (SActionTime)ConfigManager.getInstance().getConf(SActionTime.class).get(timeid);
        if (cfg == null) {
            if (BattleField.logger.isDebugEnabled()) {
                BattleField.logger.debug((Object)("没有配战斗时间参数的timeid = " + timeid));
            }
            return 0;
        }
        return cfg.actiontime;
    }

    public static int getMinScriptTime(int standardtime) {
        int minpercent = ScriptTimeCalc.getScriptTimeByTimeId(31);
        return standardtime * minpercent / 100;
    }

    public static int getMaxScriptTime(int standardtime) {
        int maxpercent = ScriptTimeCalc.getScriptTimeByTimeId(32);
        return standardtime * maxpercent / 100;
    }
}

